//March 23, 2008
//Consumer bean on info bus
//George Koutsogiannakis
import java.awt.*;

import java.util.*;

import java.io.*;

import javax.infobus.*;

import java.beans.*;

public class TimeDisplay extends Canvas 

  implements InfoBusMember, InfoBusDataConsumer, Serializable {

 InfoBusMemberSupport ims;

 String time1 = "";

 String time2 = "";

 TimeZone tz = TimeZone.getDefault();

 

 public TimeDisplay() {

  ims = new InfoBusMemberSupport(null);

  try {

   ims.joinInfoBus("Time Bus");

   ims.getInfoBus().addDataConsumer(this);

  }catch (Exception e) {

   System.out.println(e.toString());

  }

 }

 public Dimension getPreferredSize() {

  return new Dimension(120,100);

 }

 public void paint(Graphics g) {

  g.drawString(time1,10,25);

  g.drawString(time2,10,75);

 }

 public void setInfoBus(InfoBus newInfoBus) 

   throws PropertyVetoException {

  ims.setInfoBus(newInfoBus);

 }

 public InfoBus getInfoBus() {

  return ims.getInfoBus();

 }

 public void addInfoBusVetoableListener(VetoableChangeListener vcl) {

  ims.addInfoBusVetoableListener(vcl);

 }

 public void removeInfoBusVetoableListener(VetoableChangeListener vcl) {

  ims.removeInfoBusVetoableListener(vcl);

 }

 public void addInfoBusPropertyListener(PropertyChangeListener pcl) {

  ims.addInfoBusPropertyListener(pcl);

 }

 public void removeInfoBusPropertyListener(PropertyChangeListener pcl) {

  ims.removeInfoBusPropertyListener(pcl);

 }

 public void propertyChange(PropertyChangeEvent e) {

 }

 public void dataItemAvailable(InfoBusItemAvailableEvent e) {

  String name = e.getDataItemName();

  if(name.equals("Time")) {

   GregorianCalendar calendar1 = 

    (GregorianCalendar) e.requestDataItem(this,null);

   GregorianCalendar calendar2 = new GregorianCalendar(tz);

   time1 = getTimeString(calendar1);

   time2 = getTimeString(calendar2);

   repaint();

  }else if(name.equals("Zone")) {

   tz = (TimeZone) e.requestDataItem(this,null);

  }

 }

 String getTimeString(GregorianCalendar calendar) {

   String hour = String.valueOf(calendar.get(Calendar.HOUR_OF_DAY));

   if(hour.length()==1) hour = "0"+hour;

   String minute = String.valueOf(calendar.get(Calendar.MINUTE));

   if(minute.length()==1) minute = "0"+minute;

   String second = String.valueOf(calendar.get(Calendar.SECOND));

   if(second.length()==1) second = "0"+second;

   TimeZone timeZone = calendar.getTimeZone();


return hour+":"+minute+":"+second+" "+timeZone.getID();

 }

 public void dataItemRevoked(InfoBusItemRevokedEvent e) {

 }


}
