//March 23, 2008
//Info Bus example bean
//George Koutsogiannakis

import java.util.*;

import java.io.*;

import javax.infobus.*;

import java.beans.*;

public class TimeGenerator extends InfoBusMemberSupport 

  implements InfoBusDataProducer, Serializable, Runnable {

 

 public TimeGenerator() {

  this(null);

 }

 public TimeGenerator(InfoBusMember infoBusMember) {

  super(infoBusMember);

  try {

   joinInfoBus("Time Bus");

   getInfoBus().addDataProducer(this);


} catch (Exception e) {

   System.out.println(e.toString());

  }

 }

 public void run() {

  generateTime();

 }

 void generateTime() {

  while(true) {

   // Notify consumers

   getInfoBus().fireItemAvailable("Time",null,this);

   // Wait a second

   try{

    Thread.currentThread().sleep(1000); 

   }catch(Exception ex) {

   }

  }  

 }

 public void dataItemRequested(InfoBusItemRequestedEvent e) {

  // Get GMT time zone IDs

  String[] tzID = TimeZone.getAvailableIDs(0);

  SimpleTimeZone tz = new SimpleTimeZone(0,tzID[0]);

  GregorianCalendar calendar = new GregorianCalendar(tz);

  calendar.setTime(new Date());

  e.setDataItem(calendar);

 }

 public void propertyChange(PropertyChangeEvent e) {

 }


}