//March 23, 2008
//Second producer bean for the info bus
//George Koutsogiannakis
import java.awt.*;

import java.awt.event.*;

import java.util.*;

import java.io.*;

import javax.infobus.*;

import java.beans.*;

public class TimeZoneList extends java.awt.List 

  implements InfoBusMember, InfoBusDataProducer, 

   ItemListener, Serializable {

 InfoBusMemberSupport ims;

 TimeZone tz = TimeZone.getDefault();

 String[] tzIDs = TimeZone.getAvailableIDs();

 

 public TimeZoneList(int rows) {

  super(rows);

  ims = new InfoBusMemberSupport(null);

  try {

   ims.joinInfoBus("Time Bus");

   ims.getInfoBus().addDataProducer(this);

  }catch (Exception e) {

   System.out.println(e.toString());

  }  

  for(int i=0;i<tzIDs.length;++i) add(tzIDs[i]);

  addItemListener(this);

 }

 public void itemStateChanged(ItemEvent e) {

  int index = ((Integer) e.getItem()).intValue();

  String tzID = tzIDs[index];

  tz = TimeZone.getTimeZone(tzID);

  getInfoBus().fireItemAvailable("Zone",null,this);  

 }

 public void setInfoBus(InfoBus newInfoBus) 

   throws PropertyVetoException {

  ims.setInfoBus(newInfoBus);

 }

 public InfoBus getInfoBus() {

  return ims.getInfoBus();

 }

 public void addInfoBusVetoableListener(VetoableChangeListener vcl) {

  ims.addInfoBusVetoableListener(vcl);

 }

 public void removeInfoBusVetoableListener(VetoableChangeListener vcl) {

  ims.removeInfoBusVetoableListener(vcl);

 }

 public void addInfoBusPropertyListener(PropertyChangeListener pcl) {

  ims.addInfoBusPropertyListener(pcl);

 }

 public void removeInfoBusPropertyListener(PropertyChangeListener pcl) {

  ims.removeInfoBusPropertyListener(pcl);


}

 public void propertyChange(PropertyChangeEvent e) {

 }

 public void dataItemRequested(InfoBusItemRequestedEvent e) {

  e.setDataItem(tz);

 }


}
